<?php

namespace common\logic\Order\Order\Module;

use common\logic\AbstractModule;
use common\logic\Order\Order\Repository\OrderRepository;
use common\logic\Order\Order\Service\OrderBuilder;
use common\logic\Order\Order\Service\OrderDefinition;
use common\logic\Order\Order\Service\OrderSolver;
use common\logic\Order\Order\Service\OrderManager;

/**
 * @mixin OrderDefinition
 * @mixin OrderSolver
 * @mixin OrderRepository
 * @mixin OrderBuilder
 */
class OrderModule extends AbstractModule
{
    public function getServices(): array
    {
        return [
            OrderDefinition::class,
            OrderSolver::class,
            OrderRepository::class,
            OrderBuilder::class,
            OrderManager::class
        ];
    }

    public function getDefinition(): OrderDefinition
    {
        return OrderDefinition::getInstance();
    }

    public function getSolver(): OrderSolver
    {
        return OrderSolver::getInstance();
    }

    public function getRepository(): OrderRepository
    {
        return OrderRepository::getInstance();
    }

    public function getBuilder(): OrderBuilder
    {
        return OrderBuilder::getInstance();
    }

    public function getUtils(): OrderManager
    {
        return OrderManager::getInstance();
    }
}